cURL/libcURL up to 7.50.1 TLS Certificate lib/vtls/nss.c SelectClientCert improper authentication

entryeditHistoryDiffjsonxmlCTI
CVSS Meta Temp Score
CVSS is a standardized scoring system to determine possibilities of attacks. The Temp Score considers temporal factors like disclosure, exploit and countermeasures. The unique Meta Score calculates the average score of different sources to provide a normalized scoring system.
Current Exploit Price (≈)
Our analysts are monitoring exploit markets and are in contact with vulnerability brokers. The range indicates the observed or calculated exploit price to be seen on exploit markets. A good indicator to understand the monetary effort required for and the popularity of an attack.
CTI Interest Score
Our Cyber Threat Intelligence team is monitoring different web sites, mailing lists, exploit markets and social media networks. The CTI Interest Score identifies the interest of attackers and the security community for this specific vulnerability in real-time. A high score indicates an elevated risk to be targeted for this vulnerability.
7.2$0-$5k0.00

A vulnerability was found in cURL and libcURL up to 7.50.1 (Network Utility Software). It has been rated as critical. This issue affects the function SelectClientCert in the library lib/vtls/nss.c of the component TLS Certificate Handler. The manipulation with an unknown input leads to a weak authentication vulnerability. Using CWE to declare the problem leads to CWE-287. Impacted is confidentiality, integrity, and availability.

The weakness was published 09/07/2016 as Incorrect reuse of client certificates as confirmed advisory (Website). The advisory is shared at curl.haxx.se. The identification of this vulnerability is CVE-2016-7141 since 09/05/2016. The exploitation is known to be easy. The attack may be initiated remotely. No form of authentication is needed for a successful exploitation. Technical details are known, but no exploit is available.

The vulnerability scanner Nessus provides a plugin with the ID 95917 (macOS 10.12.x < 10.12.2 Multiple Vulnerabilities), which helps to determine the existence of the flaw in a target environment. It is assigned to the family MacOS X Local Security Checks and running in the context combined. The commercial vulnerability scanner Qualys is able to test this issue with plugin 176814 (Debian Security Update for curl (DLA 1568-1)).

Upgrading to version 7.50.2 eliminates this vulnerability. A possible mitigation has been published immediately after the disclosure of the vulnerability. The vulnerability will be addressed with the following lines of code:

if(!strncmp(nickname, pem_slotname, sizeof(pem_slotname) - 1U)) {
  failf(data, "NSS: refusing previously loaded certificate from file: %s",
        nickname);
  return SECFailure;
}

The vulnerability is also documented in the databases at SecurityFocus (BID 92754), SecurityTracker (ID 1036739) and Tenable (95917). Similar entries are available at 87463, 90449, 91659 and 91680.

Productinfoedit

Type

Name

CPE 2.3infoedit

CPE 2.2infoedit

CVSSv3infoedit

VulDB Meta Base Score: 7.5
VulDB Meta Temp Score: 7.2

VulDB Base Score: 7.5
VulDB Temp Score: 7.2
VulDB Vector: 🔍
VulDB Reliability: 🔍

NVD Base Score: 7.5
NVD Vector: 🔍

CVSSv2infoedit

AVACAuCIA
🔍🔍🔍🔍🔍🔍
🔍🔍🔍🔍🔍🔍
🔍🔍🔍🔍🔍🔍
VectorComplexityAuthenticationConfidentialityIntegrityAvailability
unlockunlockunlockunlockunlockunlock
unlockunlockunlockunlockunlockunlock
unlockunlockunlockunlockunlockunlock

VulDB Base Score: 🔍
VulDB Temp Score: 🔍
VulDB Reliability: 🔍

NVD Base Score: 🔍

Exploitinginfoedit

Class: Weak authentication
CWE: CWE-287
ATT&CK: Unknown

Local: No
Remote: Yes

Availability: 🔍
Status: Not defined

Price Prediction: 🔍
Current Price Estimation: 🔍

0-Dayunlockunlockunlockunlock
Todayunlockunlockunlockunlock

Nessus ID: 95917
Nessus Name: macOS 10.12.x < 10.12.2 Multiple Vulnerabilities
Nessus File: 🔍
Nessus Risk: 🔍
Nessus Family: 🔍
Nessus Context: 🔍

OpenVAS ID: 14611
OpenVAS Name: Amazon Linux Local Check: alas-2016-742
OpenVAS File: 🔍
OpenVAS Family: 🔍

Qualys ID: 🔍
Qualys Name: 🔍

Threat Intelligenceinfoedit

Threat: 🔍
Adversaries: 🔍
Geopolitics: 🔍
Economy: 🔍
Predictions: 🔍
Remediation: 🔍

Countermeasuresinfoedit

Recommended: Upgrade
Status: 🔍

Reaction Time: 🔍
0-Day Time: 🔍
Exposure Time: 🔍

Upgrade: cURL/libcURL 7.50.2

Timelineinfoedit

09/05/2016 🔍
09/06/2016 +1 days 🔍
09/07/2016 +1 days 🔍
09/07/2016 +0 days 🔍
09/07/2016 +0 days 🔍
09/08/2016 +1 days 🔍
10/03/2016 +25 days 🔍
12/16/2016 +74 days 🔍
04/12/2019 +847 days 🔍

Sourcesinfoedit

Advisory: Incorrect reuse of client certificates
Status: Confirmed
Confirmation: 🔍

CVE: CVE-2016-7141 (🔍)
SecurityFocus: 92754 - cURL/libcURL CVE-2016-7141 Certificate Validation Security Bypass Vulnerability
SecurityTracker: 1036739

See also: 🔍

Entryinfoedit

Created: 09/08/2016 10:23 PM
Updated: 04/12/2019 09:14 AM
Changes: (23) vulnerability_cwe vulnerability_cvss3_vuldb_av vulnerability_cvss3_vuldb_ac vulnerability_cvss3_vuldb_pr vulnerability_cvss3_vuldb_ui vulnerability_cvss3_vuldb_s vulnerability_cvss3_vuldb_c vulnerability_cvss3_vuldb_i vulnerability_cvss3_vuldb_a advisory_confirm_url source_cve_assigned source_cve_nvd_published source_securityfocus source_securityfocus_date source_securityfocus_class source_nessus_id source_nessus_name source_nessus_filename source_nessus_family source_openvas_id source_openvas_filename source_openvas_title source_openvas_family
Complete: 🔍

Comments

No comments yet. Please log in to comment.

Interested in the pricing of exploits?

See the underground prices here!